#include <windows.h>
#include <stdio.h>
#include "server.h"

#pragma comment (lib, "ws2_32.lib")
///////////////     ////////////
DWORD WINAPI AcceptTh(LPVOID pThArg);			//    
DWORD WINAPI Server(LPVOID pThArg);				//  .   -  

struct sockaddr_in	SrvSAddr;
WSADATA	WSStartData;
static SOCKET	SrvSock;						//  () 
///////////////   ///////////////////
HANDLE hEvent_printf;	//     printf
HANDLE hSemaphoreFree;	//   ,      Task 
HANDLE hSemaphoreJob;   //   ,      
HANDLE hSemaphoreCons;	//   ,       
////////////////////////////////////////////
CRITICAL_SECTION csl;							//        
												//        
TASK Task[MAX_TASKS];							//  
												//  : 0 -  ,
												//               0 -   
DWORD jobCounter = 0;							//     

int main(DWORD argc, LPCSTR argv[])				//   IP   
{
	DWORD	ith,								//    
			tstatus;							//     
	SERVER_ARG srv_arg[MAX_CLIENTS];			//   
	HANDLE hAcceptTh = NULL;

	WSAStartup(MAKEWORD(2, 0), &WSStartData);

	//       printf.
	hEvent_printf = CreateEvent(NULL, FALSE, TRUE, "printf");

	//      .
	// ------
	// hSemaphoreFree -    ,         
	// hSemaphoreJob  -    ,        
	// hSemaphoreCons -    ,       
	hSemaphoreFree = CreateSemaphore(NULL, MAX_TASKS, MAX_TASKS, "FreeCell");
	hSemaphoreJob  = CreateSemaphore(NULL, 0, MAX_TASKS, "Job");
	hSemaphoreCons = CreateSemaphore(NULL, 0, MAX_CLIENTS, "Consumer");

	//   "" //
	for (ith = 0; ith < MAX_CLIENTS; ith++)
	{
		srv_arg[ith].number = ith;				//   
		srv_arg[ith].status = 0;				//  -  
		srv_arg[ith].sock = 0;					//  - 
		srv_arg[ith].srv_thd = 0;				//   - 
	}

	//   
	InitializeCriticalSection(&csl);
	EnterCriticalSection(&csl);

	//   
	for (ith = 0; ith < MAX_TASKS; ith++)
	{
		Task[ith].length = 0;					//    ..
		Task[ith].status = 0;					//  
	}

	LeaveCriticalSection(&csl);

	//   
	SrvSock = socket(AF_INET, SOCK_STREAM, 0);
	SrvSAddr.sin_family = AF_INET;
	SrvSAddr.sin_addr.s_addr = htonl(INADDR_ANY);	//    IP-
	SrvSAddr.sin_port = htons(SERVER_PORT);			//  

	bind(SrvSock, (struct sockaddr *) &SrvSAddr, sizeof(SrvSAddr));
	listen(SrvSock, MAX_CLIENTS);

	// ,     ,   
	WaitForSingleObject(hEvent_printf, INFINITE);

	printf("     \n");
	printf(" ...\n");

	//      -      
	SetEvent(hEvent_printf);

	//     ,    //
	//        .                 //
	while (TRUE)
	{
		for (ith = 0; ith < MAX_CLIENTS;)	//    
		{
			if (srv_arg[ith].status == 1 || srv_arg[ith].status == 3)
			{	//  ,      //

				//    
				WaitForSingleObject(srv_arg[ith].srv_thd, INFINITE);

				//      
				CloseHandle(srv_arg[ith].srv_thd);
				// : , ,   

				srv_arg[ith].status = 0;	//    
			}

			if (srv_arg[ith].status == 0)
				break;						//   ,      
			ith = (ith+1) % MAX_CLIENTS;	//  : 0..MAX_CLIENTS-1, 0..MAX_CLIENTS-1, ...
			if (ith == 0) Sleep(1000);		//          
			//   //
		}

		//      //
		//          //
		hAcceptTh = CreateThread(NULL, 0, AcceptTh, &srv_arg[ith], 0, NULL);

		while (TRUE)	//   
		{
			tstatus = WaitForSingleObject(hAcceptTh, CS_TIMEOUT);
			if (tstatus == WAIT_OBJECT_0)
				break;	//   //
		}

		CloseHandle(hAcceptTh);		//  ,  .     - 
		hAcceptTh = NULL;			//    
	}

	printf(" .    \n");
	//   ,     //
	if (hAcceptTh != NULL)
		TerminateThread(hAcceptTh, 0);
	//      //
	shutdown(SrvSock, 2);
	closesocket(SrvSock);
	WSACleanup();

	//        .
	//    ,   accept,   
	// .      ,     
	//      .

	for (ith = 0; ith < MAX_CLIENTS; ith++)	//        
		if (srv_arg[ith].status != 0)		//   ( )?
		{									//  -      
			WaitForSingleObject(srv_arg[ith].srv_thd, INFINITE);
			CloseHandle(srv_arg[ith].srv_thd);
		}

	DeleteCriticalSection(&csl);

	return 0;
}

DWORD WINAPI AcceptTh(LPVOID pThArg)
{
//  ,          //
//   .      //
//                                                    //
	SERVER_ARG *ThArg = ((SERVER_ARG *) pThArg);	//    
													//  SERVER_ARG ( )
	ThArg->sock = accept(SrvSock, NULL, NULL);

	//  .    //
	ThArg->status = 2;								//    
	
	//  ,     
	ThArg->srv_thd = CreateThread(NULL, 0, Server, pThArg, 0, NULL);

	return 0;
}

DWORD WINAPI Server(LPVOID pThArg)
//   
{
	SERVER_ARG *ThArg = ((SERVER_ARG *) pThArg);	//    
													//  SERVER_ARG ( )
	DWORD what = 0;		// ,  ,    0 -  - 
						//  . 1 - , 2 - 
	DWORD iCell;		//    
	char buf[30];		//   

	while (TRUE)
	{
		switch (what)
		{
		case 0:	// init
			//    .  ,       
			if (recv(ThArg->sock, buf, sizeof(buf), 0) == SOCKET_ERROR)
				break;

			//    "0",   
			//  - ,      
			if (atoi(buf) == 0)
			{
				what = 2;	//       
				
				//     -     
				ReleaseSemaphore(hSemaphoreCons, 1, NULL);

				WaitForSingleObject(hEvent_printf, INFINITE);
				printf("  %i \"\" \n", ThArg->number);
				SetEvent(hEvent_printf);
				break;
			}
			else
			{
				what = 1;	//       

				WaitForSingleObject(hEvent_printf, INFINITE);
				printf("  %i \"\" \n", ThArg->number);
				SetEvent(hEvent_printf);
			} //     "else"  switch  ,     case 1
			  // ..    ,    ,   -
			  // 
		case 1:	// producer - 
			//    
			if (recv(ThArg->sock, buf, sizeof(buf), 0) == SOCKET_ERROR)
				break; //  -  

			// ,         
			WaitForSingleObject(hSemaphoreFree, INFINITE);
			// ,       
			EnterCriticalSection(&csl);

			//      
			for (iCell = 0; iCell < MAX_TASKS && Task[iCell].status != 0; iCell++);

			//   
			Task[iCell].length = atoi(buf);	//     
			Task[iCell].status = 1;			//     
			jobCounter++;					//    
			LeaveCriticalSection(&csl);		//    

			//   ,      .    
			//    -,    .
			ReleaseSemaphore(hSemaphoreJob, 1, NULL);

			WaitForSingleObject(hEvent_printf, INFINITE);
			printf("   %i.    : %i\n", ThArg->number, jobCounter);
			if (jobCounter == MAX_TASKS)
				printf("  !\n");
			SetEvent(hEvent_printf);

			break;
		case 2: // consumer - 
			// ,  
			WaitForSingleObject(hSemaphoreJob, INFINITE);

			//    -       
			EnterCriticalSection(&csl);

			//   
			for (iCell = 0; iCell < MAX_TASKS && Task[iCell].status == 0; iCell++);
			
			Task[iCell].status = 2;		// ,     
			wsprintf(buf, "%i", Task[iCell].length);
			
			//   
			LeaveCriticalSection(&csl);

			//   
			send(ThArg->sock, buf, strlen(buf), 0);

			if (recv(ThArg->sock, buf, sizeof(buf), 0) != SOCKET_ERROR)	//    ?
			{		// 
				Task[iCell].status = 0;				//  
				jobCounter--;						//    
				WaitForSingleObject(hEvent_printf, INFINITE);
				printf(" %i   %i\n", iCell, ThArg->number);
				SetEvent(hEvent_printf);
			}

			//  ,        
			ReleaseSemaphore(hSemaphoreFree, 1, NULL);
			break;
		}
	}
	WaitForSingleObject(hEvent_printf, INFINITE);
	printf(" %i \n", ThArg->number);
	SetEvent(hEvent_printf);

	shutdown(SrvSock, 2);
	closesocket(SrvSock);

	return 0;
}